#!/usr/bin/perl

require "librairie.pl";

# This CGI take the new values of the rule and replaces the rule in the file
# For return, it shows the new list of rules
use CGI;
$html = new CGI;

    $vide = 0;

    $posi = $html->param('ligne');
    $part1 = $html->param('part1');
    if($part1 eq '') 
    {
    	$vide = 1;
    }

    $part2 = $html->param('part2');
    if($part2 eq '') 
    {
    	$part2 = '0/32';
    }	
    

    $interface = $html->param('interface');
    $style = $html->param('style');
    $portmap = $html->param('portmap');
    $intport = $html->param('port');

    $rule = &GenereNAT($part1, $part2, $interface, $style, $portmap, $intport);

    if($vide == 0 && $rule ne 'erreur')
    {
     &ModifRule($rule, $posi, $natrules);
     &PageResult($natrules, $nathome);
    }
#    if($vide == 1 && $rule ne 'erreur')
#    {
#     &Erreur($rule);
#    }
    



# Change the old rule with the new rule in the file
sub ModifRule
{
    my($rule, $posi, $fichier)=@_;
    $rule = $rule ." \n";

    my(@tabout, $i, $j);

    open(FILE, "<$fichier") || die "Erreur d'ouverture de $fichier";
    my(@lignes) = <FILE>;
    my($nbelemtab) = $#lignes+1;
    close(FILE);
    
    if($nbelemtab >= $posi && ($veri3 = &checkPart($posi)) != 0)
    {
        for($i = 0; $i<$posi-1; $i++)
        {
    	    $tabout[$i] = $lignes[$i];
        }
        $tabout[$i] = $rule;
        for($j = $i+1; $j<$nbelemtab; $j++)
        {
    	    $tabout[$j] = $lignes[$j];
        }
        open(FILE, ">$fichier") || die "Erreur d'ouverture de $fichier";
        print FILE @tabout;
        close(FILE);
    }
    else 
    {
        &ecritFich($rule, $fichier);
    }

}



# This sub routine makes a NAT rules with some details like : source address, interface, ...
# This subroutine receive :
# $part1 and $part2 : source and destination address
# $interface : interface : actually it's always tun0
# $style : it's what's sort of NAT rule we'll generate (map, map-block, bimap)
# $portmap : it's the protocol we want to use (tcp, udp, tcp/udp)
# $intport : it's the interval where we can use port into (1000:2000)
# The sub routine returns the rule or 'erreur' if there was somethings wrong
sub GenereNAT
{
    my($part1, $part2, $interface, $style, $portmap, $intport) = @_;
    
# Definition of the action : map, map-block, bimap
     $style = $style . ' ';
   
# Source and destination
# verification if the address of the source likes 132.13.12.1/24
    if(($verip1 = &verifAdress($part1))==0)
    {
        &Erreur(2);
        return 'erreur';
    }	
    if($part2 ne '0/32')
    {
# verification if the address of the destination likes 132.13.12.1/24
       if(($verip2 = &verifAdress($part2))==0)
       {
           &Erreur(3);
           return 'erreur';
       }	
    }

# portmap
    if($portmap eq 'none' || $intport eq '' || ($veri = &veriIntP($intport)) == 0)
    {
      $pm = '';
    }
    else
    {
      $pm = ' portmap ' . $portmap . ' ' . $intport;
    }
    
    
#Generation of the rule.
    my($rule) = $style . $interface . ' ' . $part1 . ' -> ' . $part2 . $pm;
    return $rule;	
}



# This subroutine check if the port range is OK
# Input : $adr : this is a string witch contain the port range
# Output : 1 if OK, 0 if not OK
sub veriIntP
{
    my($adr) = @_;
    if($adr eq '')
    {
        return 0;
    }
    else
    {
    	($v1, $v2, $v3) =  split(/:/, $adr);
    	print "adr : $adr, v1 : $v1, v2 : $v2, v3 : $v3";
        if($v1 eq '' ||	$v2 eq '')
        {
            return 0;
        }
        if(($veri = &checkPart($v1)) == 0)
        {
            return 0;	
        }
        elsif(($veri2 = &checkPart($v2)) == 0 )
        {
            return 0;	
        }
        elsif($v3 ne '')
        {
            return 0;	
        }
        return 1;
        
    }
	
}

# The subroutines 'Erreur', 'PageResult' are taken of from the librairie






