#!/usr/bin/perl

require "librairie.pl";


# This CGI insert a new rule into the file
# We take the value of the param and genere a rule that we'll insert into the file
# For return we show the new list of rule (PageResult)
use CGI;
$html = new CGI;


    $part1 = $html->param('part1');

    $part2 = $html->param('part2');
    if($part2 eq '') 
    {
    	$part2 = '0/32';
    }	
    

    $interface = $html->param('interface');
    $style = $html->param('style');
    $portmap = $html->param('portmap');
    $intport = $html->param('port');

    $posi = $html->param('ligne');
    $rule = &GenereNAT($part1, $part2, $interface, $style, $portmap, $intport);

    if($rule ne 'erreur')
    {
     &WriteRule($rule, $posi, $natrules);
     &PageResult($natrules, $nathome);
    }
    
   
# This sub routine makes a NAT rules with some details like : source address, interface, ...
# This subroutine receive :
# $part1 and $part2 : source and destination address
# $interface : interface : actually it's always tun0
# $style : it's what's sort of NAT rule we'll generate (map, map-block, bimap)
# $portmap : it's the protocol we want to use (tcp, udp, tcp/udp)
# $intport : it's the interval where we can use port into (1000:2000)
# The sub routine returns the rule or 'erreur' if there was somethings wrong
sub GenereNAT
{
    my($part1, $part2, $interface, $style, $portmap, $intport) = @_;
    
     $style = $style . ' ';
    
# Source and destination addresses
# verification if the address of the source likes 132.13.12.1/24
    if(($verip1 = &verifAdress($part1))==0)
    {
        &Erreur(2);
        return 'erreur';
    }	
    if($part2 ne '0/32')
    {
# verification if the address of the destination likes 132.13.12.1/24
       if(($verip2 = &verifAdress($part2))==0)
       {
           &Erreur(3);
           return 'erreur';
       }	
    }

# portmap
    if($portmap eq 'none' || ($veri = &veriIntP($intport)) == 0)
    {
      $pm = '';
    }
    else
    {
      $pm = ' portmap ' . $portmap . ' ' . $intport;
    }
    
    

#Generation of the rule.
    my($rule) = $style . $interface . ' ' . $part1 . ' -> ' . $part2 . $pm;
    return $rule;	
}




# This subroutine check if the port range is OK
# Input : $adr : this is a string witch contain the port range
# Output : 1 if OK, 0 if not OK
sub veriIntP
{
    my($adr) = @_;
    if($adr eq '')
    {
        return 0;
    }
    else
    {
    	($v1, $v2, $v3) =  split(/:/, $adr);
    	print "adr : $adr, v1 : $v1, v2 : $v2, v3 : $v3";
        if($v1 eq '' ||	$v2 eq '')
        {
            return 0;
        }
        if(($veri = &checkPart($v1)) == 0)
        {
            return 0;	
        }
        elsif(($veri2 = &checkPart($v2)) == 0 )
        {
            return 0;	
        }
        elsif($v3 ne '')
        {
            return 0;	
        }
        return 1;
        
    }
	
}



# The subroutines 'Erreur', 'PageResult' are taken of from the librairie
    
